/*
 *
 * THIS SOFTWARE IS PROVIDED UNDER GPL LICENCE, "AS IS" AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION, MDD, ILLNESS) HOWEVER CAUSED AND 
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class diveplanner extends MIDlet implements ItemStateListener, CommandListener {

//    static String lang = "it";
    private String t_title; // presentazione all'inizio del form
    private String t_dive1; // titolo prima immersione
    private String t_dive2; // titolo seconda immersione
    private String t_dive3; // titolo terza immersione 
    private String t_air; // aria
    private String t_ean32;
    private String t_ean36;
    private String t_mix; // label "Miscela"
    private String t_depth; // profondità immersione
    private String t_dtime; // tempo d'immersione
    private String t_surf; // tempo di superficie
    private String t_pg; // gruppo di pressione
    private String t_exit;
    private String t_compute;
    private String t_error;
    private String t_out;

    private static final Command CMD_EXIT = new Command("EXIT", Command.EXIT, 1);
    private static final Command CMD_SHOW = new Command("COMPUTE", Command.SCREEN, 1);
    private Display display;
    private Form mainForm;

    private ChoiceGroup gas1;     // Choice group for air mix.
    private TextField depth1;
    private TextField diveTime1;
    private StringItem pressureGroup1;

    private StringItem pressureGroup12;    
    private TextField pause12;

    private ChoiceGroup gas2;
    private TextField depth2;
    private TextField diveTime2;
    private StringItem pressureGroup2;

    private StringItem pressureGroup23;    
    private TextField pause23;

    private ChoiceGroup gas3;
    private TextField depth3;
    private TextField diveTime3;
    private StringItem pressureGroup3;


    public diveplanner() {

        translate();

        display = Display.getDisplay(this);
        
        mainForm = new Form("Dive Planner");
        mainForm.append(t_title);
        
        // A string array for air mix descriptions.
        String[] listaMiscele = { t_air, t_ean32, t_ean36 };
        
        // and I will some icons also...
        Image[] icoMiscele = null;
        try {
            Image icoair = Image.createImage("/gas/aria.png");
            Image icoean32 = Image.createImage("/gas/ean32.png");
            Image icoean36 = Image.createImage("/gas/ean36.png");
            icoMiscele = new Image[] { icoair, icoean32, icoean36 };
        } catch (java.io.IOException err) {
            // Ignore the error. I think J2ME works fine anyway.
        }
        
        
        /********************
         ***  First dive  ***
         ********************/
        mainForm.append(" ");
        StringItem dive1 = new StringItem(t_dive1,"");
        mainForm.append(dive1);
                
        // Create the gas mix choice group (pop up) for the first dive.
        gas1 = new ChoiceGroup(t_mix, ChoiceGroup.POPUP, listaMiscele, icoMiscele);
        mainForm.append(gas1);

        // Ask for the planned maximum depth for dive no. 1
        depth1 = new TextField(t_depth, null, 4, TextField.DECIMAL);
        mainForm.append(depth1);
        
        // Ask for the planned maximum dive time for dive no. 1
        diveTime1 = new TextField(t_dtime, null, 3, TextField.NUMERIC);
        mainForm.append(diveTime1);
        
        // Show of the pressure group just after the first dive (click on compute)
        pressureGroup1 = new StringItem(t_pg, "-\n", StringItem.PLAIN);
        mainForm.append(pressureGroup1);
        

        /*************************************************************
         ************************************************************/

        mainForm.append(new StringItem("\n","************", StringItem.PLAIN));

        // Enter the minimum surface time in the HHMM format
        pause12 = new TextField(t_surf, "0000", 4, TextField.NUMERIC);
        mainForm.append(pause12);
        
        // Show of the pressure group just after the surface interval 
        // between the first and the second dive (click on compute)
        pressureGroup12 = new StringItem(t_pg, "-\n", StringItem.PLAIN);
        mainForm.append(pressureGroup12);

        mainForm.append(" \n ");
                
        /**********************
         **    Second dive   **
         **********************/
        StringItem dive2 = new StringItem(t_dive2,"");
        mainForm.append(dive2);
                
        // Chose the gas mix choice group (pop up) for dive 2.
        gas2 = new ChoiceGroup(t_mix, ChoiceGroup.POPUP, listaMiscele, icoMiscele);
        mainForm.append(gas2);
        
        // Enter maximum depth for dive 2
        depth2 = new TextField(t_depth, null, 4, TextField.DECIMAL);
        mainForm.append(depth2);
        
        // Enter maximum dive time for dive 2
        diveTime2 = new TextField(t_dtime, null, 3, TextField.NUMERIC);
        mainForm.append(diveTime2);
        
        // Show of the pressure group just after the second dive (click on compute)
        pressureGroup2 = new StringItem(t_pg, "-\n",0);
        mainForm.append(pressureGroup2);

        /*************************************************************
         ************************************************************/

        mainForm.append(new StringItem("\n","************", StringItem.PLAIN));
        
        // Enter the minimum surface time in the HHMM format
        pause23 = new TextField(t_surf, "0000", 4, TextField.NUMERIC);
        mainForm.append(pause23);
        
        // Show of the pressure group just after the surface interval 
        // between the first and the second dive (click on compute)
        pressureGroup23 = new StringItem(t_pg, "-\n", StringItem.PLAIN);
        mainForm.append(pressureGroup23);

        mainForm.append(" \n ");
                
        /**********************
         **    Third dive   **
         **********************/
        StringItem dive3 = new StringItem(t_dive3,"");
        mainForm.append(dive3);
                
        // Chose the gas mix choice group (pop up) for dive 3.
        gas3 = new ChoiceGroup(t_mix, ChoiceGroup.POPUP, listaMiscele, icoMiscele);
        mainForm.append(gas3);
        
        // Enter maximum depth for dive 3
        depth3 = new TextField(t_depth, null, 4, TextField.DECIMAL);
        mainForm.append(depth3);
        
        // Enter maximum dive time for dive 3
        diveTime3 = new TextField(t_dtime, null, 3, TextField.NUMERIC);
        mainForm.append(diveTime3);
        
        // Show of the pressure group just after the third dive (click on compute)
        pressureGroup3 = new StringItem(t_pg, "-\n",0);
        mainForm.append(pressureGroup3);

        /*************************************************************
         ************************************************************/

        mainForm.addCommand(CMD_EXIT);
        mainForm.addCommand(CMD_SHOW);
        mainForm.setCommandListener(this);
        
    }

    public void startApp() { //protected
       display.setCurrent(mainForm);


    }
    
    public void commandAction(Command c, Displayable d) {
        if (c == CMD_EXIT) {
            destroyApp(false);
            notifyDestroyed();
        }
        if (c == CMD_SHOW) {
            // To compute if the diver is inside of the security limits, we need to know
            // the sequence of his/her pressure groups.
            char pg1 = ' ';
            char pg12 = ' ';
            char pg2 = ' ';
            char pg23 = ' ';
            char pg3= ' ';
            
            // Check if depth and dive time for the first dive are given 
            // If yes, compute the pressure group
            try { float d1 = Float.parseFloat(depth1.getString());
                  int t1 = Integer.parseInt(diveTime1.getString());
                  int g1 = gas1.getSelectedIndex();
                  pg1 = diveTable1(g1, d1, t1);
                  pressureGroup1.setText(String.valueOf(pg1));
                }
            catch (java.lang.NumberFormatException err) { 
                  pressureGroup1.setText(t_error); 
                }
            if (pg1 == '#') {pressureGroup1.setText(t_out); } // out of limit!
            
            // Check surface stop between first and second dive and compute the new pressure group
            if ( pressureGroup1.getText() == t_error ) { pressureGroup12.setText(t_error); } else {
            try { int pausa = 0;
                  try {pausa = Integer.parseInt(pause12.getString()); }
                  catch (java.lang.NumberFormatException err) { pausa = 0; pause12.setString("0000");}
                  pg12 = diveTable2(pg1, pausa);
                  pressureGroup12.setText(String.valueOf(pg12));
                }
            catch (java.lang.NumberFormatException err) { 
                  pressureGroup12.setText(t_error); 
                }
            }
            
            // Check if depth and dive time for the second are given
            if ( pressureGroup12.getText() == t_error ) { pressureGroup2.setText(t_error); } else {
            try { float d2 = Float.parseFloat(depth2.getString());
                  int t2 = Integer.parseInt(diveTime2.getString());
                  int g2 = gas2.getSelectedIndex();
                  // Once we get depth and air mix, we can compute the residual nitrogen time...
                  int rnt = diveTable3(g2, pg12, d2);
                  // ... that we can add to the actual dive time, to find the pressure group after the second dive.
                  pg2 = diveTable1(g2, d2, t2 + rnt);
                  pressureGroup2.setText(String.valueOf(pg2));
                }
            catch (java.lang.NumberFormatException err) { 
                  pressureGroup2.setText(t_error); 
                }
            }
            if (pg2 == '#') {pressureGroup2.setText(t_out); } // out of limit!
            if (pg12 == '?') {pressureGroup2.setText(t_error); } // out of limit!

            // Check surface stop between second and third dive and compute the new pressure group
            if ( pressureGroup2.getText() == t_error ) { pressureGroup23.setText(t_error); } else {
            try { int pausa = 0;
                  try {pausa = Integer.parseInt(pause23.getString()); }
                  catch (java.lang.NumberFormatException err) { pausa = 0; pause23.setString("0000");}
                  pg23 = diveTable2(pg2, pausa);
                  pressureGroup23.setText(String.valueOf(pg23));
                }
            catch (java.lang.NumberFormatException err) { 
                  pressureGroup23.setText(t_error); 
                }
            }
            
            // Check if depth and dive time for the second are given
            if ( pressureGroup23.getText() == t_error ) { pressureGroup3.setText(t_error); } else {
            try { float d3 = Float.parseFloat(depth3.getString());
                  int t3 = Integer.parseInt(diveTime3.getString());
                  int g3 = gas3.getSelectedIndex();
                  // Once we get depth and air mix, we can compute the residual nitrogen time...
                  int rnt = diveTable3(g3, pg23, d3);
                  // ... that we can add to the actual dive time, to find the pressure group after the second dive.
                  pg3 = diveTable1(g3, d3, t3 + rnt);
                  pressureGroup3.setText(String.valueOf(pg3));
                }
            catch (java.lang.NumberFormatException err) { 
                  pressureGroup3.setText(t_error); 
                }
            }
            if (pg3 == '#') {pressureGroup3.setText(t_out); } // out of limit!
            if (pg23 == '?') {pressureGroup3.setText(t_error); } // out of limit!

//            int m1 = gas1.getSelectedIndex();
//            String d1 = depth1.getString();
//            String t1 = diveTime1.getString();
//            float a;  a = Float.parseFloat(d1) + Float.parseFloat(t1);
//            pressureGroup1.setText(String.valueOf(a));
//            pressureGroup1.setText(gas1.getString(gas1.getSelectedIndex())); 

        }
    }

    public void destroyApp(boolean unconditional) { //protected
    }

    public void pauseApp() { //protected
    }

    public void itemStateChanged(Item item) {
    }

    public void translate(){
        String lang = "en";//System.getProperty("microedition.locale").substring(0,2);
    
	if (lang == "it") { // if it is Italian...
		t_title = "Per il calcolo della curva di sicurezza nell'immersione ricreativa, fino a due immersioni ripetitive.";
		t_dive1 = "Prima immersione :\n********************";
		t_dive2 = "Seconda immersione :\n***********************";
		t_dive3 = "Terza immersione :\n********************";
		t_air = "Aria"; 
                t_ean32 = "EAN 32% (MOD 33m a PO2=1.4)";
                t_ean36 = "EAN 36% (MOD 28m a PO2=1.4)";
		t_mix = "Miscela";
		t_depth = "Profondità [m]: ";
		t_dtime = "Tempo immersione [min]: ";
		t_surf = "Pausa superficie [HHMM]: "; 
		t_pg = "Gruppo di pressione: ";
		t_exit = "Esci";
		t_compute = "Calcola";
		t_error = "Errore";
                t_out = "Fuori curva";
		}
	if (lang == "fr") { // if it is French...
		t_title = "Pour le calcul de la courbe de sécurité dans la plongée loisir, jusqu'à deux plongées répétitives.";
		t_dive1 = "Première plongée :\n******************";
		t_dive2 = "Deuxième plongée :\n**********************";
		t_dive3 = "Troisième plongée :\n**********************";
		t_air = "Air"; 
                t_ean32 = "EAN 32% (MOD 33m à PO2=1.4)";
                t_ean36 = "EAN 36% (MOD 28m à PO2=1.4)";
		t_mix = "Mix gas";
		t_depth = "Profondeur [m]: ";
		t_dtime = "Temps plongée [min]: ";
		t_surf = "Pause surface [HHMM]: "; 
		t_pg = "Groupe de pression: ";
		t_exit = "Fin";
		t_compute = "Calcule";
		t_error = "Erreur!";
                t_out = "Hors limite!";
		}
	if (lang == "en") { // if it is English...
		t_title = "To compute the security curve for recreative diving, (up to two consecutive dives).";
		t_dive1 = "First dive :\n**********";
		t_dive2 = "Second dive :\n*************";
		t_dive3 = "Third dive :\n**********";
		t_air = "Air"; 
                t_ean32 = "EAN 32% (MOD 33m for PO2=1.4)";
                t_ean36 = "EAN 36% (MOD 28m for PO2=1.4)";
		t_mix = "Mix";
		t_depth = "Depth [m]: ";
		t_dtime = "Bottom time [min]: ";
		t_surf = "Surface interval [HHMM]: "; 
		t_pg = "Pressure group: ";
		t_exit = "Exit";
		t_compute = "Compute";
		t_error = "Error";
                t_out = "Out of limits!";
		}
    }

    public char diveTable1(int mix, float depth, int corrtime) { 
        char a = 'A';
        switch (mix) {
        case 0: // it's air
             if (depth > 0) {
                   if (corrtime > 60) { a = 'B'; }
                   if (corrtime > 120) { a = 'C'; }
                   if (corrtime > 210) { a = 'D'; }
                   if (corrtime > 300) { a = '#'; }
             }
             if (depth > 3) { 
                   if (corrtime > 35) { a = 'B'; }
                   if (corrtime > 70) { a = 'C'; }
                   if (corrtime > 110) { a = 'D'; }
                   if (corrtime > 160) { a = 'E'; }
                   if (corrtime > 225) { a = 'F'; }
                   if (corrtime > 350) { a = '#'; }
             }
             if (depth > 4.5) { 
                   if (corrtime > 25) { a = 'B'; }
                   if (corrtime > 50) { a = 'C'; }
                   if (corrtime > 75) { a = 'D'; }
                   if (corrtime > 110) { a = 'E'; }
                   if (corrtime > 135) { a = 'F'; }
                   if (corrtime > 180) { a = 'G'; }
                   if (corrtime > 240) { a = 'H'; }
                   if (corrtime > 325) { a = '#'; }
             }
             if (depth > 6) { 
                   if (corrtime > 20) { a = 'B'; }
                   if (corrtime > 35) { a = 'C'; }
                   if (corrtime > 55) { a = 'D'; }
                   if (corrtime > 75) { a = 'E'; }
                   if (corrtime > 100) { a = 'F'; }
                   if (corrtime > 125) { a = 'G'; }
                   if (corrtime > 160) { a = 'H'; }
                   if (corrtime > 190) { a = 'I'; }
                   if (corrtime > 245) { a = '#'; }
             }
             if (depth > 7.5) { 
                   if (corrtime > 15) { a = 'B'; }
                   if (corrtime > 30) { a = 'C'; }
                   if (corrtime > 45) { a = 'D'; }
                   if (corrtime > 60) { a = 'E'; }
                   if (corrtime > 75) { a = 'F'; }
                   if (corrtime > 95) { a = 'G'; }
                   if (corrtime > 120) { a = 'H'; }
                   if (corrtime > 145) { a = 'I'; }
                   if (corrtime > 170) { a = 'J'; }
                   if (corrtime > 205) { a = '#'; }
             }
             if (depth > 9) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 40) { a = 'E'; }
                   if (corrtime > 50) { a = 'F'; }
                   if (corrtime > 60) { a = 'G'; }
                   if (corrtime > 80) { a = 'H'; }
                   if (corrtime > 100) { a = 'I'; }
                   if (corrtime > 120) { a = 'J'; }
                   if (corrtime > 140) { a = 'K'; }
                   if (corrtime > 160) { a = '#'; }
             }
             if (depth > 10.5) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 30) { a = 'E'; }
                   if (corrtime > 40) { a = 'F'; }
                   if (corrtime > 50) { a = 'G'; }
                   if (corrtime > 70) { a = 'H'; }
                   if (corrtime > 80) { a = 'I'; }
                   if (corrtime > 100) { a = 'J'; }
                   if (corrtime > 110) { a = 'K'; }
                   if (corrtime > 130) { a = '#'; }
             }
             if (depth > 12) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 25) { a = 'E'; }
                   if (corrtime > 30) { a = 'F'; }
                   if (corrtime > 40) { a = 'G'; }
                   if (corrtime > 50) { a = 'H'; }
                   if (corrtime > 60) { a = 'I'; }
                   if (corrtime > 70) { a = '#'; }
             }
             if (depth > 15) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 20) { a = 'E'; }
                   if (corrtime > 25) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 40) { a = 'H'; }
                   if (corrtime > 50) { a = '#'; }
             }
             if (depth > 18) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 35) { a = 'H'; }
                   if (corrtime > 40) { a = '#'; }
             }
             if (depth > 21) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 25) { a = 'G'; }
                   if (corrtime > 30) { a = '#'; }
             }
             if (depth > 24) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 12) { a = 'E'; }
                   if (corrtime > 15) { a = 'F'; }
                   if (corrtime > 20) { a = 'G'; }
                   if (corrtime > 25) { a = '#'; }
             }
             if (depth > 27) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 7) { a = 'D'; }
                   if (corrtime > 10) { a = 'E'; }
                   if (corrtime > 15) { a = 'F'; }
                   if (corrtime > 20) { a = '#'; }
             }
             if (depth > 30) { 
                   if (corrtime > -1) { a = 'C'; }
                   if (corrtime > 5) { a = 'D'; }
                   if (corrtime > 10) { a = 'E'; }
                   if (corrtime > 13) { a = 'F'; }
                   if (corrtime > 15) { a = '#'; }
             }
             if (depth > 33) { 
                   if (corrtime > -1) { a = 'C'; }
                   if (corrtime > 5) { a = 'D'; }
                   if (corrtime > 10) { a = '#'; }
             }
             if (depth > 36) { 
                   if (corrtime > -1) { a = 'C'; }
                   if (corrtime > 5) { a = '#'; }
             }
             if (depth > 39) { 
                   if (corrtime > -1) { a = '#'; }
             }
        break;
        case 1: // it's nitrox 32%
             if (depth > 0) {
                   if (corrtime > 35) { a = 'B'; }
                   if (corrtime > 70) { a = 'C'; }
                   if (corrtime > 110) { a = 'D'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 6.5) { 
                   if (corrtime > 25) { a = 'B'; }
                   if (corrtime > 50) { a = 'C'; }
                   if (corrtime > 75) { a = 'D'; }
                   if (corrtime > 110) { a = 'E'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 8) { 
                   if (corrtime > 20) { a = 'B'; }
                   if (corrtime > 35) { a = 'C'; }
                   if (corrtime > 55) { a = 'D'; }
                   if (corrtime > 75) { a = 'E'; }
                   if (corrtime > 100) { a = 'F'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 10) { 
                   if (corrtime > 15) { a = 'B'; }
                   if (corrtime > 30) { a = 'C'; }
                   if (corrtime > 45) { a = 'D'; }
                   if (corrtime > 60) { a = 'E'; }
                   if (corrtime > 75) { a = 'F'; }
                   if (corrtime > 95) { a = 'G'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 12) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 40) { a = 'E'; }
                   if (corrtime > 50) { a = 'F'; }
                   if (corrtime > 60) { a = 'G'; }
                   if (corrtime > 80) { a = 'H'; }
                   if (corrtime > 100) { a = 'I'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 13.5) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 30) { a = 'E'; }
                   if (corrtime > 40) { a = 'F'; }
                   if (corrtime > 50) { a = 'G'; }
                   if (corrtime > 70) { a = 'H'; }
                   if (corrtime > 80) { a = 'I'; }
                   if (corrtime > 100) { a = 'J'; }
                   if (corrtime > 110) { a = 'K'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 15) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 25) { a = 'E'; }
                   if (corrtime > 30) { a = 'F'; }
                   if (corrtime > 40) { a = 'G'; }
                   if (corrtime > 50) { a = 'H'; }
                   if (corrtime > 60) { a = 'I'; }
                   if (corrtime > 70) { a = '#'; }
             }
             if (depth > 18) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 20) { a = 'E'; }
                   if (corrtime > 25) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 40) { a = 'H'; }
                   if (corrtime > 50) { a = '#'; }
             }
             if (depth > 22) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 35) { a = 'H'; }
                   if (corrtime > 40) { a = '#'; }
             }
             if (depth > 26) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 25) { a = 'G'; }
                   if (corrtime > 30) { a = '#'; }
             }
             if (depth > 29) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 12) { a = 'E'; }
                   if (corrtime > 15) { a = 'F'; }
                   if (corrtime > 20) { a = 'G'; }
                   if (corrtime > 25) { a = '#'; }
             }
             if (depth > 32) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 7) { a = 'D'; }
                   if (corrtime > 10) { a = 'E'; }
                   if (corrtime > 15) { a = 'F'; }
                   if (corrtime > 20) { a = '#'; }
             }
             if (depth > 36) { 
                   if (corrtime > -1) { a = '#'; }
             }
        break;
        case 2: // it's nitrox 36%
             if (depth > 0) {
                   if (corrtime > 35) { a = 'B'; }
                   if (corrtime > 70) { a = 'C'; }
                   if (corrtime > 110) { a = 'D'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 7.5) { 
                   if (corrtime > 25) { a = 'B'; }
                   if (corrtime > 50) { a = 'C'; }
                   if (corrtime > 75) { a = 'D'; }
                   if (corrtime > 110) { a = 'E'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 9) { 
                   if (corrtime > 20) { a = 'B'; }
                   if (corrtime > 35) { a = 'C'; }
                   if (corrtime > 55) { a = 'D'; }
                   if (corrtime > 75) { a = 'E'; }
                   if (corrtime > 100) { a = 'F'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 11) { 
                   if (corrtime > 15) { a = 'B'; }
                   if (corrtime > 30) { a = 'C'; }
                   if (corrtime > 45) { a = 'D'; }
                   if (corrtime > 60) { a = 'E'; }
                   if (corrtime > 75) { a = 'F'; }
                   if (corrtime > 95) { a = 'G'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 13) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 40) { a = 'E'; }
                   if (corrtime > 50) { a = 'F'; }
                   if (corrtime > 60) { a = 'G'; }
                   if (corrtime > 80) { a = 'H'; }
                   if (corrtime > 100) { a = 'I'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 15) { 
                   if (corrtime > 5) { a = 'B'; }
                   if (corrtime > 15) { a = 'C'; }
                   if (corrtime > 25) { a = 'D'; }
                   if (corrtime > 30) { a = 'E'; }
                   if (corrtime > 40) { a = 'F'; }
                   if (corrtime > 50) { a = 'G'; }
                   if (corrtime > 70) { a = 'H'; }
                   if (corrtime > 80) { a = 'I'; }
                   if (corrtime > 100) { a = 'J'; }
                   if (corrtime > 110) { a = 'K'; }
                   if (corrtime > 120) { a = '#'; }
             }
             if (depth > 17) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 25) { a = 'E'; }
                   if (corrtime > 30) { a = 'F'; }
                   if (corrtime > 40) { a = 'G'; }
                   if (corrtime > 50) { a = 'H'; }
                   if (corrtime > 60) { a = 'I'; }
                   if (corrtime > 70) { a = '#'; }
             }
             if (depth > 20) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 10) { a = 'C'; }
                   if (corrtime > 15) { a = 'D'; }
                   if (corrtime > 20) { a = 'E'; }
                   if (corrtime > 25) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 40) { a = 'H'; }
                   if (corrtime > 50) { a = '#'; }
             }
             if (depth > 24) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 30) { a = 'G'; }
                   if (corrtime > 35) { a = 'H'; }
                   if (corrtime > 40) { a = '#'; }
             }
             if (depth > 28) { 
                   if (corrtime > -1) { a = 'B'; }
                   if (corrtime > 5) { a = 'C'; }
                   if (corrtime > 10) { a = 'D'; }
                   if (corrtime > 15) { a = 'E'; }
                   if (corrtime > 20) { a = 'F'; }
                   if (corrtime > 25) { a = 'G'; }
                   if (corrtime > 30) { a = '#'; }
             }
             if (depth > 31) { 
                   if (corrtime > -1) { a = '#'; }
             }
        break;
        }
        return a;
    }




    public char diveTable2(char pg, int pausa) { // format of *pausa* is HHMM.
        char a = '?'; //return a '?' if there is an error
        if (pg == 'A') { a = 'A'; }
        if (pg == 'B') {
            if (pausa >= 321) { a = 'A'; }
            if (pausa < 321) { a = 'B'; } 
        }
        if (pg == 'C') {
            if (pausa >= 450) { a = 'A'; } 
            if (pausa < 450) { a = 'B'; } 
            if (pausa < 140) { a = 'C'; } 
        }
        if (pg == 'D') {
            if (pausa >= 549) { a = 'A'; } 
            if (pausa < 549) { a = 'B'; } 
            if (pausa < 239) { a = 'C'; } 
            if (pausa < 110) { a = 'D'; } 
        }
        if (pg == 'E') {
            if (pausa >= 635) { a = 'A'; } 
            if (pausa < 635) { a = 'B'; } 
            if (pausa < 325) { a = 'C'; } 
            if (pausa < 158) { a = 'D'; } 
            if (pausa < 55) { a = 'E'; } 
        }
        if (pg == 'F') {
            if (pausa >= 706) { a = 'A'; } 
            if (pausa < 706) { a = 'B'; } 
            if (pausa < 358) { a = 'C'; } 
            if (pausa < 229) { a = 'D'; } 
            if (pausa < 130) { a = 'E'; } 
            if (pausa < 46) { a = 'F'; } 
        }
        if (pg == 'G') {
            if (pausa >= 736) { a = 'A'; } 
            if (pausa < 736) { a = 'B'; } 
            if (pausa < 426) { a = 'C'; } 
            if (pausa < 259) { a = 'D'; } 
            if (pausa < 200) { a = 'E'; } 
            if (pausa < 116) { a = 'F'; } 
            if (pausa < 41) { a = 'G'; } 
        }
        if (pg == 'H') {
            if (pausa >= 800) { a = 'A'; } 
            if (pausa < 800) { a = 'B'; } 
            if (pausa < 450) { a = 'C'; } 
            if (pausa < 321) { a = 'D'; } 
            if (pausa < 224) { a = 'E'; } 
            if (pausa < 142) { a = 'F'; } 
            if (pausa < 107) { a = 'G'; } 
            if (pausa < 37) { a = 'H'; } 
        }
        if (pg == 'I') {
            if (pausa >= 822) { a = 'A'; } 
            if (pausa < 822) { a = 'B'; } 
            if (pausa < 513) { a = 'C'; } 
            if (pausa < 344) { a = 'D'; } 
            if (pausa < 245) { a = 'E'; } 
            if (pausa < 203) { a = 'F'; } 
            if (pausa < 130) { a = 'G'; } 
            if (pausa < 100) { a = 'H'; } 
            if (pausa < 34) { a = 'I'; } 
        }
        if (pg == 'J') {
            if (pausa >= 851) { a = 'A'; } 
            if (pausa < 851) { a = 'B'; } 
            if (pausa < 541) { a = 'C'; } 
            if (pausa < 403) { a = 'D'; } 
            if (pausa < 305) { a = 'E'; } 
            if (pausa < 221) { a = 'F'; } 
            if (pausa < 148) { a = 'G'; } 
            if (pausa < 120) { a = 'H'; } 
            if (pausa < 55) { a = 'I'; } 
            if (pausa < 32) { a = 'J'; } 
        }
        if (pg == 'K') {
            if (pausa >= 859) { a = 'A'; } 
            if (pausa < 859) { a = 'B'; } 
            if (pausa < 549) { a = 'C'; } 
            if (pausa < 420) { a = 'D'; } 
            if (pausa < 322) { a = 'E'; } 
            if (pausa < 239) { a = 'F'; } 
            if (pausa < 204) { a = 'G'; } 
            if (pausa < 136) { a = 'H'; } 
            if (pausa < 112) { a = 'I'; } 
            if (pausa < 50) { a = 'J'; } 
            if (pausa < 29) { a = 'K'; } 
        }
        if (pausa > 1200) { a = '-';}

        return a;

    }

    public int diveTable3(int mix, char pg, float depth) {
    // mix=0:air  mix=1:EAN32   mix=3:EAN36
        int rnt = 777; // Residual Nitrogen Time. Returns 777 if error.
        switch (mix) {
        case 0: // it's air
            if (pg == 'A') {
                rnt = 39;
                if (depth > 3) { rnt = 18; }
                if (depth > 6) { rnt = 12; }
                if (depth > 9) { rnt = 7; }
                if (depth > 12) { rnt = 6; }
                if (depth > 15) { rnt = 5; }
                if (depth > 18) { rnt = 4; }
                if (depth > 24) { rnt = 3; }
                if (depth > 39) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'B') {
                rnt = 88;
                if (depth > 3) { rnt = 39; }
                if (depth > 6) { rnt = 25; }
                if (depth > 9) { rnt = 17; }
                if (depth > 12) { rnt = 13; }
                if (depth > 15) { rnt = 11; }
                if (depth > 18) { rnt = 9; }
                if (depth > 21) { rnt = 8; }
                if (depth > 24) { rnt = 7; }
                if (depth > 30) { rnt = 6; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'C') {
                rnt = 159;
                if (depth > 3) { rnt = 62; }
                if (depth > 6) { rnt = 39; }
                if (depth > 9) { rnt = 25; }
                if (depth > 12) { rnt = 21; }
                if (depth > 15) { rnt = 17; }
                if (depth > 18) { rnt = 15; }
                if (depth > 21) { rnt = 13; }
                if (depth > 24) { rnt = 11; }
                if (depth > 27) { rnt = 10; }
                if (depth > 33) { rnt = 9; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'D') {
                rnt = 279;
                if (depth > 3) { rnt = 88; }
                if (depth > 6) { rnt = 54; }
                if (depth > 9) { rnt = 37; }
                if (depth > 12) { rnt = 29; }
                if (depth > 15) { rnt = 24; }
                if (depth > 18) { rnt = 20; }
                if (depth > 21) { rnt = 18; }
                if (depth > 24) { rnt = 16; }
                if (depth > 27) { rnt = 14; }
                if (depth > 30) { rnt = 13; }
                if (depth > 33) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'E') {
                rnt = 120;
                if (depth > 6) { rnt = 70; }
                if (depth > 9) { rnt = 49; }
                if (depth > 12) { rnt = 38; }
                if (depth > 15) { rnt = 30; }
                if (depth > 18) { rnt = 26; }
                if (depth > 21) { rnt = 23; }
                if (depth > 24) { rnt = 20; }
                if (depth > 27) { rnt = 18; }
                if (depth > 30) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'F') {
                rnt = 159;
                if (depth > 6) { rnt = 88; }
                if (depth > 9) { rnt = 61; }
                if (depth > 12) { rnt = 47; }
                if (depth > 15) { rnt = 36; }
                if (depth > 18) { rnt = 31; }
                if (depth > 21) { rnt = 28; }
                if (depth > 24) { rnt = 24; }
                if (depth > 27) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'G') {
                rnt = 208;
                if (depth > 6) { rnt = 109; }
                if (depth > 9) { rnt = 73; }
                if (depth > 12) { rnt = 56; }
                if (depth > 15) { rnt = 44; }
                if (depth > 18) { rnt = 37; }
                if (depth > 21) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'H') {
                rnt = 279;
                if (depth > 6) { rnt = 132; }
                if (depth > 9) { rnt = 87; }
                if (depth > 12) { rnt = 66; }
                if (depth > 15) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'I') {
                rnt = 399;
                if (depth > 6) { rnt = 159; }
                if (depth > 9) { rnt = 101; }
                if (depth > 12) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'J') {
                rnt = 190;
                if (depth > 9) { rnt = 116; }
                if (depth > 12) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'K') {
                rnt = 888; // Returns 888 if error.
            }
        break;
        case 1: // it's nitrox 32%
            if (pg == 'A') {
                rnt = 39;
                if (depth > 5) { rnt = 18; }
                if (depth > 8) { rnt = 12; }
                if (depth > 12) { rnt = 7; }
                if (depth > 15) { rnt = 6; }
                if (depth > 18) { rnt = 5; }
                if (depth > 22) { rnt = 4; }
                if (depth > 29) { rnt = 3; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'B') {
                rnt = 88;
                if (depth > 5) { rnt = 39; }
                if (depth > 8) { rnt = 25; }
                if (depth > 12) { rnt = 17; }
                if (depth > 15) { rnt = 13; }
                if (depth > 18) { rnt = 11; }
                if (depth > 22) { rnt = 9; }
                if (depth > 26) { rnt = 8; }
                if (depth > 29) { rnt = 7; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'C') {
                rnt = 159;
                if (depth > 5) { rnt = 62; }
                if (depth > 8) { rnt = 39; }
                if (depth > 12) { rnt = 25; }
                if (depth > 15) { rnt = 21; }
                if (depth > 18) { rnt = 17; }
                if (depth > 22) { rnt = 15; }
                if (depth > 26) { rnt = 13; }
                if (depth > 29) { rnt = 11; }
                if (depth > 32) { rnt = 10; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'D') {
                rnt = 279;
                if (depth > 5) { rnt = 88; }
                if (depth > 8) { rnt = 54; }
                if (depth > 12) { rnt = 37; }
                if (depth > 15) { rnt = 29; }
                if (depth > 18) { rnt = 24; }
                if (depth > 22) { rnt = 20; }
                if (depth > 26) { rnt = 18; }
                if (depth > 29) { rnt = 16; }
                if (depth > 32) { rnt = 14; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'E') {
                rnt = 120;
                if (depth > 8) { rnt = 70; }
                if (depth > 12) { rnt = 49; }
                if (depth > 15) { rnt = 38; }
                if (depth > 18) { rnt = 30; }
                if (depth > 22) { rnt = 26; }
                if (depth > 26) { rnt = 23; }
                if (depth > 29) { rnt = 20; }
                if (depth > 32) { rnt = 18; }
                if (depth > 36) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'F') {
                rnt = 159;
                if (depth > 8) { rnt = 88; }
                if (depth > 12) { rnt = 61; }
                if (depth > 15) { rnt = 47; }
                if (depth > 18) { rnt = 36; }
                if (depth > 22) { rnt = 31; }
                if (depth > 26) { rnt = 28; }
                if (depth > 29) { rnt = 24; }
                if (depth > 32) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'G') {
                rnt = 208;
                if (depth > 8) { rnt = 109; }
                if (depth > 12) { rnt = 73; }
                if (depth > 15) { rnt = 56; }
                if (depth > 18) { rnt = 44; }
                if (depth > 22) { rnt = 37; }
                if (depth > 26) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'H') {
                rnt = 279;
                if (depth > 8) { rnt = 132; }
                if (depth > 12) { rnt = 87; }
                if (depth > 15) { rnt = 66; }
                if (depth > 18) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'I') {
                rnt = 399;
                if (depth > 8) { rnt = 159; }
                if (depth > 12) { rnt = 101; }
                if (depth > 15) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'J') {
                rnt = 190;
                if (depth > 12) { rnt = 116; }
                if (depth > 15) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'K') {
                rnt = 888; // Returns 888 if error.
            }
        break;
        case 2: // it's nitrox 36%
            if (pg == 'A') {
                rnt = 39;
                if (depth > 6) { rnt = 18; }
                if (depth > 9) { rnt = 12; }
                if (depth > 13) { rnt = 7; }
                if (depth > 17) { rnt = 6; }
                if (depth > 20) { rnt = 5; }
                if (depth > 24) { rnt = 4; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'B') {
                rnt = 88;
                if (depth > 6) { rnt = 39; }
                if (depth > 9) { rnt = 25; }
                if (depth > 13) { rnt = 17; }
                if (depth > 17) { rnt = 13; }
                if (depth > 20) { rnt = 11; }
                if (depth > 24) { rnt = 9; }
                if (depth > 28) { rnt = 8; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'C') {
                rnt = 159;
                if (depth > 6) { rnt = 62; }
                if (depth > 9) { rnt = 39; }
                if (depth > 13) { rnt = 25; }
                if (depth > 17) { rnt = 21; }
                if (depth > 20) { rnt = 17; }
                if (depth > 24) { rnt = 15; }
                if (depth > 28) { rnt = 13; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'D') {
                rnt = 279;
                if (depth > 6) { rnt = 88; }
                if (depth > 9) { rnt = 54; }
                if (depth > 13) { rnt = 37; }
                if (depth > 17) { rnt = 29; }
                if (depth > 20) { rnt = 24; }
                if (depth > 24) { rnt = 20; }
                if (depth > 28) { rnt = 18; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'E') {
                rnt = 120;
                if (depth > 9) { rnt = 70; }
                if (depth > 13) { rnt = 49; }
                if (depth > 17) { rnt = 38; }
                if (depth > 20) { rnt = 30; }
                if (depth > 24) { rnt = 26; }
                if (depth > 28) { rnt = 23; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'F') {
                rnt = 159;
                if (depth > 9) { rnt = 88; }
                if (depth > 13) { rnt = 61; }
                if (depth > 17) { rnt = 47; }
                if (depth > 20) { rnt = 36; }
                if (depth > 24) { rnt = 31; }
                if (depth > 28) { rnt = 28; }
                if (depth > 31) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'G') {
                rnt = 208;
                if (depth > 9) { rnt = 109; }
                if (depth > 13) { rnt = 73; }
                if (depth > 17) { rnt = 56; }
                if (depth > 20) { rnt = 44; }
                if (depth > 24) { rnt = 37; }
                if (depth > 28) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'H') {
                rnt = 279;
                if (depth > 9) { rnt = 132; }
                if (depth > 13) { rnt = 87; }
                if (depth > 17) { rnt = 66; }
                if (depth > 20) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'I') {
                rnt = 399;
                if (depth > 9) { rnt = 159; }
                if (depth > 13) { rnt = 101; }
                if (depth > 17) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'J') {
                rnt = 190;
                if (depth > 13) { rnt = 116; }
                if (depth > 17) { rnt = 888; } // Returns 888 if error.
            }
            if (pg == 'K') {
                rnt = 888; // Returns 888 if error.
            }
        break;
        }
        return rnt;
    }
}


